import React, { useEffect, useReducer, useState } from "react";
import { Link, Navigate, Outlet, Route, Routes } from "react-router-dom";
import "../App.css";
import FarmerOrders from "./FarmerOrders";
import ProfileSettings from "./ProfileSettings";

const AdminDashboard = ({ setUser, setAdmin }) => {
  const [name, setName] = useState("");
  const farmer_id = sessionStorage.getItem("user_id");
  async function getName() {
    try {
      const response = await fetch(
        `https://sanamtshongpoen-api.onrender.com/users/${farmer_id}/name`,
        {
          method: "GET",
        }
      );

      const userNameRes = await response.json();
      setName(userNameRes);
    } catch (err) {
      console.error(err.message);
    }
  }

  const logout = (e) => {
    e.preventDefault();
    localStorage.removeItem("token");
    sessionStorage.removeItem("token");

    setAdmin(false);
    sessionStorage.setItem("admin", false);
    setUser(null);
    window.location.replace("https://himalayan-harvest.user-kn.serv00.net");
  };
  useEffect(() => {
    getName();
  }, []);

  return (
    <div class="container-fluid ">
      <div class="row flex-nowrap bg-light">
        <div class="col-auto col-md-3 col-xl-2 px-sm-2 px-0 bg-light shadow">
          <div class="d-flex flex-column align-items-center align-items-sm-start px-3 pt-2 text-white min-vh-100">
            <div class="fs-5 d-none d-sm-inline text-dark fs-4 fw-1">
              <a class="navbar-brand">
                <Link to="/admindashboard">
                <svg width="210" height="40" viewBox="0 0 458 90" className="ms-auto" fill="none" xmlns="http://www.w3.org/2000/svg">
                  <path d="M59.0827 26.84C61.6627 26.84 64.0227 26.91 66.3627 26.77C66.7127 26.75 67.2227 25.77 67.2927 25.2C67.9927 19.73 68.6127 14.26 69.2627 8.79002C69.4627 7.08002 69.6527 5.37002 69.9027 3.67002C70.2727 1.18002 71.9027 -0.17998 74.1127 0.10002C76.2427 0.37002 77.5427 2.21002 77.2627 4.68002C76.4827 11.45 75.6727 18.22 74.8827 24.99C74.8327 25.45 74.8327 25.91 74.7927 26.51C77.0827 26.51 79.2627 26.51 81.4327 26.51C82.9727 26.51 84.5227 26.37 86.0627 26.46C88.0827 26.57 89.5127 28.14 89.5427 30.06C89.5727 32.09 88.1427 33.65 85.9927 33.74C82.4927 33.9 78.9827 34.01 75.4827 34.04C74.2627 34.05 73.6827 34.38 73.5427 35.7C72.6927 43.36 71.7627 51 70.8727 58.66C70.6327 60.73 71.4227 62.18 73.1027 62.84C74.7427 63.48 76.2327 63.04 77.4327 61.35C84.0427 51.93 90.6627 42.51 97.1827 33.03C99.4527 29.73 98.6227 25.84 95.3927 23.44C94.6327 22.87 93.8027 22.4 93.0627 21.8C91.4627 20.48 91.1027 18.25 92.1927 16.7C93.3627 15.03 95.5727 14.63 97.4027 15.8C98.6527 16.6 99.8727 17.45 101.083 18.31C107.053 22.59 108.393 29.7 104.353 35.87C102.953 38 101.443 40.06 99.9827 42.15C92.0627 53.48 84.1427 64.81 76.2427 76.15C74.2027 79.07 71.5427 80.67 67.8927 80.03C63.8027 79.31 61.3527 75.79 61.8327 71.34C62.2927 67.1 62.8327 62.87 63.3427 58.63C64.2327 51.22 65.1227 43.8 65.9927 36.39C66.0627 35.82 65.9927 35.23 65.9927 34.57C63.5627 34.57 61.2027 34.51 58.8527 34.64C58.5127 34.66 57.9927 35.53 57.9327 36.05C56.7927 45.52 55.7227 55 54.6327 64.48C54.0227 69.78 53.4327 75.08 52.8027 80.37C52.5027 82.86 50.8627 84.32 48.6927 84.1C46.4427 83.87 45.0227 82.08 45.3027 79.53C46.1527 71.81 47.0727 64.11 47.9827 56.4C49.8327 40.75 51.7027 25.1 53.5627 9.45002C53.6227 8.92002 53.6827 8.39002 53.8227 7.88002C54.3327 5.99002 56.1627 4.74002 57.9627 5.00002C59.6927 5.26002 61.2027 6.90002 61.0527 8.78002C60.7427 12.62 60.2327 16.44 59.8027 20.26C59.5627 22.42 59.3227 24.58 59.0627 26.87L59.0827 26.84Z" fill="#198754"/>
                  <path d="M40.653 54.19C43.113 54.19 45.523 54.24 47.933 54.13C48.223 54.12 48.663 53.31 48.713 52.83C49.803 43.83 50.843 34.82 51.893 25.82C52.563 20.05 53.213 14.28 53.923 8.52004C54.243 5.88004 55.933 4.37004 58.073 4.63004C60.283 4.90004 61.733 6.93004 61.433 9.47004C60.013 21.59 58.573 33.71 57.133 45.83C55.783 57.19 54.433 68.54 53.053 79.89C52.723 82.59 51.113 84.02 48.903 83.74C46.593 83.45 45.363 81.59 45.693 78.88C46.313 73.7 46.933 68.52 47.533 63.34C47.583 62.89 47.533 62.42 47.533 61.89C45.113 61.89 42.753 61.83 40.403 61.95C40.053 61.97 39.533 62.81 39.463 63.32C38.583 70.26 37.773 77.2 36.953 84.15C36.913 84.5 36.893 84.86 36.833 85.21C36.423 87.47 34.803 88.89 32.843 88.72C30.773 88.54 29.283 86.78 29.453 84.47C29.653 81.81 30.033 79.17 30.343 76.52C30.893 71.82 31.453 67.11 32.043 62.12C31.263 62.12 30.643 62.11 30.013 62.12C26.983 62.18 23.953 62.31 20.923 62.3C18.783 62.29 17.243 60.75 17.173 58.79C17.103 56.77 18.633 55.1 20.843 54.99C24.403 54.82 27.973 54.73 31.533 54.66C32.533 54.64 32.993 54.37 33.113 53.29C33.983 45.58 34.953 37.87 35.833 30.16C36.093 27.9 35.243 26.46 33.523 25.86C31.843 25.27 30.403 25.8 29.123 27.63C22.693 36.81 16.253 45.99 9.86302 55.21C7.16302 59.11 7.96302 62.96 11.863 65.67C12.593 66.18 13.363 66.65 14.003 67.26C15.383 68.57 15.553 70.62 14.493 72.12C13.443 73.61 11.393 74.16 9.74302 73.13C7.73302 71.88 5.68302 70.6 3.95302 69.01C-0.636976 64.82 -1.28698 58.28 2.30302 52.99C5.80302 47.84 9.43302 42.77 13.003 37.67C18.783 29.41 24.533 21.12 30.403 12.92C31.403 11.52 32.763 10.12 34.273 9.40004C39.683 6.80004 45.363 10.79 44.873 16.82C44.463 21.84 43.763 26.83 43.173 31.83C42.323 39.01 41.463 46.19 40.613 53.37C40.583 53.59 40.643 53.83 40.663 54.17L40.653 54.19Z" fill="#198754"/>
                  <path d="M150.684 0.960012H150.734C151.884 0.960012 152.814 1.89001 152.814 3.04001V10.72C152.814 11.87 153.744 12.8 154.894 12.8H165.484C166.634 12.8 167.564 11.87 167.564 10.72V3.03001C167.564 1.88001 168.494 0.950012 169.644 0.950012C170.794 0.950012 171.724 1.88001 171.724 3.03001V29.65C171.724 30.8 170.794 31.73 169.644 31.73C168.494 31.73 167.564 30.8 167.564 29.65V19.02C167.564 17.87 166.634 16.94 165.484 16.94H154.894C153.744 16.94 152.814 17.87 152.814 19.02V29.65C152.814 30.8 151.884 31.73 150.734 31.73H150.684C149.534 31.73 148.604 30.8 148.604 29.65V3.03001C148.604 1.88001 149.534 0.950012 150.684 0.950012V0.960012Z" fill="#333333"/>
                  <path d="M189.093 0C190.243 0 191.173 0.93 191.173 2.08V28.7C191.173 29.85 190.243 30.78 189.093 30.78C187.943 30.78 187.013 29.85 187.013 28.7V2.08C187.013 0.93 187.943 0 189.093 0Z" fill="#333333"/>
                  <path d="M233.213 1.76002L239.513 28.05C239.843 29.43 238.893 30.78 237.593 30.78H237.573C236.673 30.78 235.873 30.11 235.653 29.15L232.403 15.46C231.923 13.45 229.393 13.24 228.653 15.16L223.963 27.32C223.283 29.1 220.983 29.09 220.303 27.32L215.573 14.99C214.833 13.07 212.303 13.27 211.823 15.28L208.513 29.16C208.283 30.12 207.493 30.79 206.593 30.79C205.293 30.79 204.343 29.44 204.673 28.06L210.983 1.75002C211.463 -0.259982 214.003 -0.459982 214.733 1.46002L220.293 15.97C220.973 17.75 223.283 17.75 223.963 15.97L229.473 1.49002C230.203 -0.429982 232.743 -0.239982 233.233 1.78002L233.213 1.76002Z" fill="#333333"/>
                  <path d="M266.123 1.34002L277.593 27.81C278.193 29.2 277.223 30.78 275.773 30.78H275.743C274.963 30.78 274.243 30.3 273.923 29.55L271.403 23.72C271.083 22.97 270.363 22.49 269.583 22.49H259.063C258.273 22.49 257.563 22.98 257.243 23.73L254.763 29.54C254.443 30.29 253.723 30.78 252.943 30.78C251.493 30.78 250.523 29.21 251.123 27.82L262.493 1.35002C263.203 -0.289975 265.423 -0.299975 266.133 1.35002L266.123 1.34002ZM264.283 7.24002L259.343 18.8H269.273L264.283 7.24002Z" fill="#333333"/>
                  <path d="M293.713 0.109985C294.863 0.109985 295.793 1.03999 295.793 2.17999V24.56C295.793 25.7 296.723 26.63 297.873 26.63H303.763C304.913 26.63 305.843 27.56 305.843 28.7C305.843 29.84 304.913 30.77 303.763 30.77H293.703C292.553 30.77 291.623 29.84 291.623 28.7V2.17999C291.623 1.03999 292.553 0.109985 293.703 0.109985H293.713Z" fill="#333333"/>
                  <path d="M331.743 1.34002L343.213 27.81C343.813 29.2 342.843 30.78 341.393 30.78H341.363C340.583 30.78 339.863 30.3 339.543 29.55L337.023 23.72C336.703 22.97 335.983 22.49 335.203 22.49H324.683C323.893 22.49 323.183 22.98 322.863 23.73L320.383 29.54C320.063 30.29 319.343 30.78 318.563 30.78C317.113 30.78 316.143 29.21 316.743 27.82L328.113 1.35002C328.823 -0.289975 331.043 -0.299975 331.753 1.35002L331.743 1.34002ZM329.903 7.24002L324.963 18.8H334.893L329.903 7.24002Z" fill="#333333"/>
                  <path d="M358.323 0.109985H358.334C359.034 0.109985 359.673 0.469985 360.043 1.05999L365.334 9.65999C366.114 10.93 367.974 10.93 368.754 9.65999L373.974 1.06999C374.334 0.469985 374.984 0.109985 375.684 0.109985C377.244 0.109985 378.204 1.79999 377.394 3.11999L369.394 16.24C369.204 16.55 369.103 16.91 369.103 17.27V28.79C369.103 29.89 368.213 30.77 367.103 30.77H366.884C365.784 30.77 364.884 29.88 364.884 28.79V17.32C364.884 16.96 364.784 16.61 364.594 16.3L356.614 3.11999C355.814 1.79999 356.773 0.109985 358.323 0.109985Z" fill="#333333"/>
                  <path d="M405.643 1.34002L417.113 27.81C417.713 29.2 416.743 30.78 415.293 30.78H415.263C414.483 30.78 413.763 30.3 413.443 29.55L410.923 23.72C410.603 22.97 409.883 22.49 409.103 22.49H398.583C397.793 22.49 397.083 22.98 396.763 23.73L394.283 29.54C393.963 30.29 393.243 30.78 392.463 30.78C391.013 30.78 390.043 29.21 390.643 27.82L402.013 1.35002C402.723 -0.289975 404.943 -0.299975 405.653 1.35002L405.643 1.34002ZM403.803 7.24002L398.863 18.8H408.793L403.803 7.24002Z" fill="#333333"/>
                  <path d="M433.923 2.56999L449.513 18.48C450.833 19.83 453.133 18.9 453.133 17.02V2.19999C453.133 1.03999 454.073 0.109985 455.243 0.109985C456.403 0.109985 457.353 1.04999 457.353 2.19999V27.05C457.353 28.93 455.053 29.86 453.733 28.51L438.133 12.66C436.813 11.32 434.513 12.25 434.513 14.12V28.67C434.513 29.83 433.573 30.76 432.403 30.76C431.243 30.76 430.293 29.82 430.293 28.67V4.02999C430.293 2.14999 432.593 1.21999 433.913 2.56999H433.923Z" fill="#333333"/>
                  <path d="M151.473 47.11H151.533C153.033 47.11 154.253 48.37 154.253 49.92V60.31C154.253 61.86 155.473 63.12 156.973 63.12H170.773C172.273 63.12 173.493 61.86 173.493 60.31V49.92C173.493 48.37 174.713 47.11 176.213 47.11C177.713 47.11 178.933 48.37 178.933 49.92V85.93C178.933 87.48 177.713 88.74 176.213 88.74C174.713 88.74 173.493 87.48 173.493 85.93V71.55C173.493 70 172.273 68.74 170.773 68.74H156.973C155.473 68.74 154.253 70 154.253 71.55V85.93C154.253 87.48 153.033 88.74 151.533 88.74H151.473C149.973 88.74 148.753 87.48 148.753 85.93V49.92C148.753 48.37 149.973 47.11 151.473 47.11Z" fill="#333333"/>
                  <path d="M217.613 48.78L232.553 84.72C233.333 86.61 232.073 88.75 230.183 88.75H230.143C229.123 88.75 228.193 88.1 227.773 87.08L224.493 79.16C224.073 78.14 223.143 77.49 222.123 77.49H208.413C207.383 77.49 206.453 78.15 206.033 79.17L202.793 87.06C202.373 88.08 201.443 88.74 200.413 88.74C198.523 88.74 197.263 86.61 198.043 84.72L212.853 48.78C213.773 46.55 216.673 46.54 217.593 48.78H217.613ZM215.223 56.79L208.793 72.48H221.733L215.233 56.79H215.223Z" fill="#333333"/>
                  <path d="M252.734 49.81C252.734 48.32 253.904 47.11 255.344 47.11H261.454C265.794 47.11 269.324 48.23 272.044 50.46C274.774 52.69 276.134 55.55 276.134 59.04C276.134 61.83 275.254 64.29 273.484 66.42C272.274 67.88 270.604 69.05 268.474 69.92C266.904 70.56 266.264 72.51 267.214 73.96L274.154 84.54C275.324 86.33 274.094 88.75 271.994 88.75C271.124 88.75 270.314 88.3 269.834 87.56L259.454 71.63H258.224V86.06C258.224 87.55 257.054 88.76 255.614 88.76H255.334C253.894 88.76 252.724 87.55 252.724 86.06V49.82L252.734 49.81ZM258.224 54.91V63.91C258.224 65.48 259.524 66.7 261.034 66.6C267.264 66.19 270.384 63.78 270.384 59.37C270.384 57.61 269.914 56.16 268.964 55.04C268.014 53.92 266.754 53.16 265.174 52.75C264.114 52.48 262.714 52.3 260.984 52.21C259.494 52.13 258.224 53.36 258.224 54.9V54.91Z" fill="#333333"/>
                  <path d="M297.543 47.11C298.593 47.11 299.543 47.79 299.963 48.85L309.483 72.58C310.413 74.9 313.393 74.91 314.333 72.58L323.923 48.84C324.353 47.78 325.303 47.1 326.343 47.1H326.373C328.293 47.1 329.583 49.29 328.793 51.23L314.263 87C313.323 89.32 310.343 89.31 309.413 86.98L295.113 51.21C294.333 49.27 295.623 47.09 297.543 47.09V47.11Z" fill="#333333"/>
                  <path d="M350.753 47.11H367.613C369.113 47.11 370.333 48.37 370.333 49.92V49.99C370.333 51.54 369.113 52.8 367.613 52.8H356.183C354.683 52.8 353.463 54.06 353.463 55.61V60.38C353.463 61.93 354.683 63.19 356.183 63.19H367.613C369.113 63.19 370.333 64.45 370.333 66C370.333 67.55 369.113 68.81 367.613 68.81H356.183C354.683 68.81 353.463 70.07 353.463 71.62V80.31C353.463 81.86 354.683 83.12 356.183 83.12H367.613C369.113 83.12 370.333 84.38 370.333 85.93C370.333 87.48 369.113 88.74 367.613 88.74H350.753C349.253 88.74 348.033 87.48 348.033 85.93V49.92C348.033 48.37 349.253 47.11 350.753 47.11Z" fill="#333333"/>
                  <path d="M411.483 54.41L411.453 54.43C410.373 55.28 408.843 55.25 407.793 54.36C407.273 53.92 406.773 53.56 406.313 53.27C405.353 52.68 403.973 52.38 402.173 52.38C400.203 52.38 398.593 52.82 397.373 53.7C396.143 54.58 395.533 55.72 395.533 57.11C395.533 58.31 396.073 59.38 397.143 60.3C398.213 61.22 400.043 62.23 402.633 63.33C405.213 64.43 407.223 65.45 408.673 66.4C410.113 67.35 411.293 68.39 412.223 69.54C413.143 70.68 413.833 71.89 414.283 73.16C414.733 74.43 414.963 75.77 414.963 77.18C414.963 80.49 413.743 83.31 411.313 85.63C408.883 87.96 405.943 89.12 402.493 89.12C399.043 89.12 396.153 88.21 393.573 86.39C391.823 85.16 390.353 83.5 389.153 81.43C388.223 79.83 389.083 77.79 390.883 77.29C392.153 76.94 393.463 77.51 394.153 78.62C396.123 81.79 398.843 83.38 402.313 83.38C404.313 83.38 405.973 82.79 407.303 81.61C408.633 80.43 409.293 78.93 409.293 77.13C409.293 76.05 408.943 74.97 408.253 73.88C407.553 72.79 406.693 71.89 405.663 71.19C404.633 70.48 402.993 69.68 400.733 68.76C398.483 67.85 396.753 67.01 395.533 66.25C394.323 65.49 393.263 64.59 392.383 63.54C391.493 62.49 390.843 61.44 390.433 60.4C390.023 59.36 389.813 58.25 389.813 57.06C389.813 54.21 390.973 51.78 393.283 49.78C395.603 47.77 398.413 46.77 401.713 46.77C403.903 46.77 406.123 47.24 408.373 48.17C409.543 48.66 410.603 49.27 411.573 50.02C412.993 51.12 412.923 53.29 411.513 54.41H411.483Z" fill="#333333"/>
                  <path d="M434.583 46.76H453.743C455.243 46.76 456.463 48.03 456.463 49.59V49.66C456.463 51.23 455.243 52.49 453.743 52.49H449.573C448.073 52.49 446.853 53.76 446.853 55.32V85.9C446.853 87.47 445.633 88.73 444.133 88.73C442.633 88.73 441.413 87.46 441.413 85.9V55.32C441.413 53.75 440.193 52.49 438.693 52.49H434.553C433.053 52.49 431.833 51.22 431.833 49.66V49.59C431.833 48.02 433.053 46.76 434.553 46.76H434.583Z" fill="#333333"/>
                </svg>

                </Link>
              </a>
            </div>
            <ul
              class="nav nav-pills flex-column mb-sm-auto mb-0 align-items-center align-items-sm-start"
              id="menu"
            >
              <li>
                <Link to="dashboard" className="text-decoration-none">
                  <a class="nav-link px-0 align-middle">
                    <i class="fs-4 text-success bi-speedometer2 "></i>
                    <span class="ms-1 text-muted d-none d-sm-inline">
                      Dashboard
                    </span>{" "}
                  </a>
                </Link>
              </li>

              <li>
                <a
                  href="#submenu3"
                  data-bs-toggle="collapse"
                  class="nav-link px-0 align-middle"
                >
                  <i class="fs-4 text-success bi-grid"></i>{" "}
                  <span class="ms-1 text-muted d-none d-sm-inline">Update</span>{" "}
                </a>
                <ul
                  class="collapse nav flex-column ms-1"
                  id="submenu3"
                  data-bs-parent="#menu"
                >
                  <li class="w-100">
                    <Link to="stockupload" className="text-decoration-none">
                      <a
                        href="#"
                        class="nav-link px-0 text-decoration-none text-muted"
                      >
                        <i class="fs-6 text-success bi-upload"></i>{" "}
                        <span class="d-none d-sm-inline">Stock upload</span>
                      </a>
                    </Link>
                  </li>
                  <li class="w-100">
                    <Link to="stockupdate" className="text-decoration-none">
                      <a
                        href="#"
                        class="nav-link px-0 text-decoration-none text-muted"
                      >
                        <i class="fs-6 text-success bi-clipboard2-check"></i>{" "}
                        <span class="d-none d-sm-inline">Stock Update</span>
                      </a>
                    </Link>
                  </li>
                </ul>
              </li>

              <Link to="profilesettings" className="text-decoration-none">
                <li>
                  <a href="#" class="nav-link px-0 align-middle">
                    <i class="fs-4 text-success bi-people"></i>{" "}
                    <span class="ms-1 text-muted d-none d-sm-inline">
                      Profile Settings
                    </span>{" "}
                  </a>
                </li>
              </Link>
            </ul>
            <hr />
            <div class="dropdown pb-4">
              <a
                href="#"
                class="d-flex align-items-center text-success text-decoration-none dropdown-toggle"
                id="dropdownUser1"
                data-bs-toggle="dropdown"
                aria-expanded="false"
              >
                <span class="d-none d-sm-inline mx-2">{name}</span>
              </a>
              <ul class="dropdown-menu dropdown-menu-white text-small shadow">
                <li>
                  <a class="dropdown-item" href="#">
                    <button
                      className="btn btn-danger"
                      onClick={(e) => logout(e)}
                    >
                      Sign out
                    </button>
                  </a>
                </li>
              </ul>
            </div>
          </div>
        </div>
        {/* content area */}
        <div class="col m-0 p-0 w-100 vh-100 border bg-red">
          <div
            class="overflow-auto scrollable-div"
            style={{ height: "100%", width: "100%" }}
          >
            <nav class="navbar navbar-light bg-light shadow my-2 rounded m-3">
              <div class="container-fluid mx-2">
                <a class="navbar-brand ms-auto" href="#">
                 Himalayan Harvest
                </a>
              </div>
            </nav>
            <div className="p-4">
              <Outlet></Outlet>
            </div>
          </div>
        </div>
      </div>
    </div>
  );
};

export default AdminDashboard;
